#include "stdafx.h"
#include "AlphaDecimal.hpp"

namespace Lmt {
namespace Max2Bms {
	wchar_t AlphaDecimal::m_chars[] = {
		L'0', L'1', L'2', L'3', L'4', L'5', L'6', L'7', L'8', L'9', L'A', L'B',
		L'C', L'D', L'E', L'F', L'G', L'H', L'I', L'J', L'K', L'L', L'M', L'N',
		L'O', L'P', L'Q', L'R', L'S', L'T', L'U', L'V', L'W', L'X', L'Y', L'Z',
	};
	
	AlphaDecimal::AlphaDecimal() {
		m_value = MinValue;
	}
	
	AlphaDecimal::AlphaDecimal( int value ) {
		m_value = value;
	}
	
	wstring AlphaDecimal::ToString() const {
		if (this->IsOutOfRange() == true) {
			return L"??";
		}
		else {
			wchar_t result[2] = { m_chars[m_value / 36], m_chars[m_value % 36] };
			return wstring( result, 2 );
		}
	}

	wstring AlphaDecimal::ToHexString() const {
		if (m_value < 0) {
			return L"??";
		}
		else if (m_value > 0xff) {
			return L"FF";
		}
		else {
			wchar_t result[2] = { m_chars[(m_value & 0xf0) >> 4], m_chars[m_value & 0x0f] };
			return wstring( result, 2 );
		}
	}

	int AlphaDecimal::Get( void ) const {
		return m_value;
	}

	void AlphaDecimal::Set( int value ) {
		m_value = value;
	}
	
	bool AlphaDecimal::IsOutOfRange() const {
		return m_value < MinValue || m_value > MaxValue;
	}
}
}