#include "StdAfx.h"
#include ".\bmsutility.hpp"

namespace Lmt {
namespace Max2Bms {
	wstring BmsUtility::MakeSequenceHeader( int measure, BmsChannels ch ) {
		wchar_t buffer[32];

		if ((measure < 1) || (measure > 999)) {
			return L":";
		}
		if ((ch < 0) || (ch > 99)) {
			return L":";
		}

		swprintf( buffer, L"#%03d%02d:", measure, static_cast<int>( ch ) );

		return buffer;
	}

	int BmsUtility::CalculateTotalGroove( int totalNotes ) {
		if (totalNotes < 120) {
			return 150 + (int)(((double)totalNotes / 120.0) * 150.0);
		}
		else {
			return 300 + (int)(((double)totalNotes - 120.0) / 3.6);
		}
	}
}
}
