#pragma once

#include "SoundEntry.hpp"
#include "Track.hpp"
#include "PtLoadResult.hpp"

namespace Lmt {
namespace Max2Bms {
	class PatternFile {
		typedef vector<unsigned char*>  SoundEntryArray;
		typedef vector<unsigned char*>  TrackArray;
		unsigned char *m_ppt;
		SoundEntryArray m_sentries;
		TrackArray m_tracks;
		wstring m_hash;
	public:
		PatternFile( void );
		~PatternFile( void );
		int GetSoundEntryCount( void ) const;
		int GetTrackCount( void ) const;
		int GetTotalNotes( void ) const;
		wstring GetHash( void ) const;
		bool GetSoundEntry( int index, SoundEntry &sentry ) const;
		bool GetTrack( int index, Track &track ) const;
		PtLoadResult Load( const wstring &path );
		void Clear( void );
	};
}
}
