#include "stdafx.h"
#include "SoundEntry.hpp"
#include "Utility.hpp"

namespace Lmt {
namespace Max2Bms {
	SoundEntry::SoundEntry(void) {
		m_identifier = -1;
		m_flags = 0;
		m_fileName = L"";
	}

	SoundEntry::~SoundEntry(void) {
	}

	int SoundEntry::GetIdentifier( void ) const {
		return m_identifier;
	}

	int SoundEntry::GetFlags( void ) const {
		return m_flags;
	}

	wstring SoundEntry::GetFileName( void ) const {
		return m_fileName;
	}

	bool SoundEntry::Initialize( const unsigned char *psentry ) {
		const PtFormat::SoundDef *psdef = reinterpret_cast<const PtFormat::SoundDef*>( psentry );

		m_identifier = psdef->identifier;
		m_flags = psdef->flags;
		m_fileName = Utility::StringToWString( psdef->fileName );

		return true;
	}
}
}
