// testapp.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include <iostream>
#include <fstream>
#include "maxdef.hpp"

using namespace Lmt::Max2Bms;
using namespace std;

void dump_track( const DjmaxTrackObject *ptracks, int count ) {
	for (int i = 0; i < count; i++) {
		printf( "    Pos: %8u  Type: %1u  ", ptracks[i].position, ptracks[i].objectType );
		for (int j = 0; j < 6; j++) {
			printf( "%02X ", ptracks[i].detail[j] );
		}
		printf( "\n" );
	}
}

int main(int argc, char* argv[])
{
	if (argc < 2) {
		cout << "t@Cw肵" << endl;
		return 0;
	}

	fstream fs( argv[1], ios::in | ios::binary );
	if (fs.is_open() == false) {
		cout << argv[1] << "@Jˁ[悗" << endl;
		return 0;
	}

	DjmaxScoreHeader header;
	DjmaxFileEntry fentry;
	DjmaxTrackHeader theader;
	unsigned char *ptrackData;
	int i;

	fs.read( (char*)&header, sizeof(header) );
	if (memcmp( header.signature, "PTFF", 4 ) != 0) {
		cout << "PTt@C˂" << endl;
		return 0;
	}

	cout << "-----Header Information-----" << endl;
	cout << "numberOfEztr:" << header.numberOfEztr << endl;
	cout << "numberOfSound:" << header.numberOfSound << endl;

	cout << "-----File Entries-----" << endl;
	for (i = 0; i < (int)header.numberOfSound; i++) {
		fs.read( (char*)&fentry, sizeof(fentry) );
		cout << "ID:" << (int)fentry.identifier << " ";
		cout << "flags:" << (int)fentry.flags << " ";
		cout << "fileName:" << fentry.fileName << endl;
	}

	cout << "-----Tracks-----" << endl;
	for (i = 0; i < (int)header.numberOfEztr; i++) {
		fs.read( (char*)&theader, sizeof(theader) );
		if (memcmp( theader.signature, "EZTR", 4 ) != 0) {
			cout << "EZTRFłˁ[񂾂ǂ" << endl;
			break;
		}
		if ((theader.dataLength % sizeof(DjmaxTrackObject)) != 0) {
			cout << "gbNf[^؂ˁ[" << endl;
			break;
		}

		cout << "[Track " << i + 1 << "] " << theader.trackName << endl;
		cout << "  lastPosition: " << theader.lastPosition << endl;
		cout << "  dataLength: " << theader.dataLength << endl;

		if (theader.dataLength > 0) {
			cout << "  track:" << endl;
			ptrackData = new unsigned char [theader.dataLength];
			fs.read( (char*)ptrackData, theader.dataLength );
			dump_track( (DjmaxTrackObject*)ptrackData, theader.dataLength / sizeof(DjmaxTrackObject) );
			delete [] ptrackData;
		}
	}

	return 0;
}

